/**
 * Package for Distributed MARF and MARF networking.
 */
package marf.net;

import marf.util.MARFException;


/**
 * <p>Just denotes general communication error with remote connections.
 * </p>
 *
 * $Id: CommunicationException.java,v 1.3 2006/08/13 22:44:45 mokhov Exp $
 *
 * @author Serguei Mokhov
 * @since 0.3.0.6
 * @version $Revision: 1.3 $
 */
public class CommunicationException
extends MARFException
{
	/**
	 * For serialization versioning.
	 */
	private static final long serialVersionUID = 1151261945;

	/**
	 *
	 */
	public CommunicationException()
	{
		super();
	}

	/**
	 * @param pstrMessage
	 */
	public CommunicationException(String pstrMessage)
	{
		super(pstrMessage);
	}

	/**
	 * @param pstrMessage
	 * @param poException
	 */
	public CommunicationException(String pstrMessage, Exception poException)
	{
		super(pstrMessage, poException);
	}

	/**
	 * @param poException
	 */
	public CommunicationException(Exception poException)
	{
		super(poException);
	}
}

// EOF
