
package marf.net.messaging.protocol;

import java.net.Socket;

import marf.net.CommunicationException;
import marf.util.BaseThread;


/**
 * PassMessage represents most of the TCP client-server protocol.
 * An abstract class for message passing.
 * @author Serguei Mokhov
 * @since A2
 */
public abstract class PassMessage
extends BaseThread
{
	/**
	 * The number of the port
	 */
	public static final int DEFAULT_LISTEN_PORT = 6231;

	public static final int BUFFER_SIZE = 10000;
	
	protected int iPort = DEFAULT_LISTEN_PORT;
	
	protected String strHost = "localhost";
	
	/**
	 *  buffer where the message is kept
	 */
	protected byte[] atBuffer;

	
	
	/**
	 * @return Returns the iPort.
	 */
	public synchronized int getPort() {
		return iPort;
	}

	/**
	 * @param port The iPort to set.
	 */
	public synchronized void setPort(int port) {
		iPort = port;
	}

	/**
	 * @return Returns the strHost.
	 */
	public synchronized String getHost() {
		return strHost;
	}

	/**
	 * @param strHost The strHost to set.
	 */
	public synchronized void setHost(String strHost) {
		this.strHost = strHost;
	}

	/**
	 * send message
	 * @param poMessage
	 * @param poSocket
	 * @throws Exception
	 */
	public abstract void sendMessage(Message poMessage, Socket poSocket)
	throws CommunicationException;

	/**
	 * recieve message
	 * @param poSocket
	 * @return
	 * @throws Exception
	 */
	public abstract Message receiveMessage(Socket poSocket)
	throws CommunicationException;
}

// EOF
