package marf.net.messaging.protocol.tcp;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

import marf.net.CommunicationException;
import marf.net.messaging.protocol.Message;
import marf.net.messaging.protocol.PassMessage;


/**
 * Represents the "client side" of the trade message passing.
 * @author Serguei Mokhov
 * @since A2
 */
public class Sender
extends PassMessage
{
	/**
	 * 
	 */
	public Sender()
	{
		super();
		System.out.println("client (" + getTID() +") constructed.");
	}

	/**
	 * @see ca.concordia.cse.dsb.server.messaging.protocol.PassMessage#sendMessage(ca.concordia.cse.dsb.server.messaging.protocol.Message, java.net.Socket)
	 */
	public void sendMessage(Message poMessage, Socket poSocket)
	throws CommunicationException
	{
		try
		{
			System.out.println("client (" + getTID() +"): Sending message: [" + poMessage + "]");

			DataOutputStream out =new DataOutputStream( poSocket.getOutputStream());
			ObjectOutputStream oout = new ObjectOutputStream(out);
			oout.writeObject(poMessage);
	
			System.out.println("client (" + getTID() +"): message sent: [" + poMessage + "]");
		}
		catch(IOException e)
		{
			e.printStackTrace(System.err);
			throw new CommunicationException(e);
		}
	}

	/**
	 * @see ca.concordia.cse.dsb.server.messaging.protocol.PassMessage#receiveMessage(java.net.Socket)
	 */
	public Message receiveMessage(Socket poSocket)
	throws CommunicationException
	{
		try
		{
			System.out.println("client (" + getTID() + "): receiving");
			
			DataInputStream oIN = new DataInputStream( poSocket.getInputStream());

			System.out.println("client (" + getTID() + "): packet received, converting to Message");

			ObjectInputStream oOIN = new ObjectInputStream(oIN);
			
			Message oRet = (Message)oOIN.readObject();

			System.out.println("client (" + getTID() +"): message received: [" + oRet + "]");

			return oRet;
		}
		catch(Exception e)
		{
			e.printStackTrace(System.err);
			throw new CommunicationException(e);
		}
	}
}

// EOF
