package marf.net.server.corba.Classification;


/**
* marf/net/server/corba/Classification/IClassificationCORBAOperations.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from src/marf/net/server/corba/MARF.idl
* Sunday, August 13, 2006 11:30:44 PM EDT
*/


/**
	* <p>Classification CORBA Interface.</p>
	*
	* $Id: IClassificationCORBAOperations.java,v 1.1 2007/02/19 01:13:58 mokhov Exp $
	*
	* @author Serguei Mokhov
	* @version $Revision: 1.1 $
	* @since 0.3.0.6
	*/
public interface IClassificationCORBAOperations 
{

  //		raises (CORBACommunicationException);
  boolean init (marf.net.server.corba.Storage.Configuration poConfig) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Generic classification routine.
  		* @return <code>true</code> if classification was successful; <code>false</code> otherwise
  		* @throws ClassificationException if there was an error while classifying
  		*/
  boolean classify () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Generic training routine for building/updating
  		* mean vectors in the training set.
  		*
  		* @return <code>true</code> if training was successful; <code>false</code> otherwise
  		* @throws ClassificationException if there was a problem while training
  		*/
  boolean train () throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Generic classification routine.
  	 *
  	 * @param padFeatureVector vector of features to compare with the stored ones
  	 * @return <code>true</code> if classification was successful; <code>false</code> otherwise
  	 * @throws ClassificationException if there was an error while classifying
  	 */
  boolean classifyFromFeatureVector (double[] padFeatureVector) throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Generic training routine for building/updating
  	 * mean vectors in the training set.
  	 *
  	 * @param padFeatureVector vector of features to train on
  	 * @return <code>true</code> if training was successful; <code>false</code> otherwise
  	 * @throws ClassificationException if there was a problem while training
  	 */
  boolean trainFromFeatureVector (double[] padFeatureVector) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Retrieves the likely classification result.
  		* If there were many, this will return the result with the
  		* highest statistical score or probability. The decision
  		* of whether to retrieve a maximum result (with maximum probability)
  		* or minimum result (with minimum distance) from the sample is
  		* left to be made by concrete implementations.
  		*
  		* @return Result object
  		*/
  marf.net.server.corba.Storage.Result getResult ();

  /**
  		* Retrieves the enclosed result set.
  		* @return the enclosed ResultSet object
  		*/
  marf.net.server.corba.Storage.ResultSet getResultSet ();

  /**
  		* Retrieves the features source.
  		* @return returns the FeatureExtraction reference
  		*/
  marf.net.server.corba.FeatureExtraction.IFeatureExtractionCORBA getFeatureExtraction ();

  /**
  		* Allows setting the features source.
  		* @param poFeatureExtraction the FeatureExtraction object to set
  		*/
  void setFeatureExtraction (marf.net.server.corba.FeatureExtraction.IFeatureExtractionCORBA poFeatureExtraction);
} // interface IClassificationCORBAOperations
