/**
 * 
 */
package marf.net.server.corba;

import org.omg.CosNaming.NamingContext;
import org.omg.PortableServer.POA;

import marf.net.server.IServer;


/**
 * <p>Represent a CORBA-specific server.
 * </p>
 * 
 * $Id: ICORBAServer.java,v 1.4 2006/08/14 20:39:07 mokhov Exp $
 * 
 * @author Serguei Mokhov
 * @since 0.3.0.6
 * @version $Revision: 1.4 $
 */
public interface ICORBAServer
extends IServer
{
	/**
	 * Sets the root portable object adapter (POA) for this server.
	 * @param poPOA the POA to set
	 */
	void setRootPOA(POA poPOA);

	/**
	 * Allows to query for the root portable object adapter (POA) of this server.
	 * @return the current POA
	 */
	POA getRootPOA();

	/**
	 * Registers this CORBA service withing the specified naming context.
	 * @param poNamingContext the naming context to register this server in.
	 * @throws Exception in case of any initialization or bidning errors
	 */
	void register(NamingContext poNamingContext)
	throws Exception;
}

// EOF
