package marf.net.server.corba.MARF;


/**
* marf/net/server/corba/MARF/IMARFServerCORBAOperations.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from src/marf/net/server/corba/MARF.idl
* Sunday, August 13, 2006 11:30:44 PM EDT
*/

public interface IMARFServerCORBAOperations 
{
  void setPreprocessingMethod (int piPreprocessingMethod) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Gets currently selected preprocessing method.
  		* @return one of the preprocessing methods
  		*/
  int getPreprocessingMethod ();

  /**
  		* Sets feature extraction method to be used.
  		* @param piFeatureExtractionMethod one of the allowed feature extraction methods
  		* @throws MARFException if the parameter outside of the valid range
  		*/
  void setFeatureExtractionMethod (int piFeatureExtractionMethod) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Gets currently selected feature extraction method.
  		* @return current feature extraction method
  		*/
  int getFeatureExtractionMethod ();

  /**
  		* Sets classification method to be used.
  		* @param piClassificationMethod one of the allowed classification methods
  		* @throws MARFException if the parameter outside of the valid range
  		*/
  void setClassificationMethod (int piClassificationMethod) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Gets classification method to be used.
  		* @return current classification method
  		*/
  int getClassificationMethod ();

  /**
  		* Sets input sample file format.
  		* @param piSampleFormat one of the allowed sample formats
  		*/
  void setSampleFormat (int piSampleFormat);

  /**
  		* Gets input sample file format.
  		* @return current sample format
  		*/
  int getSampleFormat ();

  /**
  		* Sets input sample file name.
  		* @param pstrFileName string representing sample file to be read
  		*/
  void setSampleFile (String pstrFileName, byte[] patSampleData);

  /**
  		* Obtains filename of a sample currently being processed.
  		* @return file name of a string representing sample file
  		*/
  String getSampleFile ();

  /**
  		* Sets directory with sample files to be read from.
  		* @param pstrSamplesDir string representing directory name
  		*/
  void setSamplesDir (String pstrSamplesDir);

  /**
  		* Sets module-specific parameters an application programmer wishes to pass on to the module.
  		* @param poModuleParams parameters' instance
  		*/
  void setModuleParams (marf.net.server.corba.Storage.ModuleParams poModuleParams);

  /**
  		* Gets module-specific parameters an application programmer passed on to the module.
  		* @return ModuleParams object reference
  		*/
  marf.net.server.corba.Storage.ModuleParams getModuleParams ();

  /**
  		* Indicates whether spectrogram is wanted as an output of a FeatureExtraction module.
  		* @param pbDump <code>true</code> if wanted, <code>false</code> if not
  		*/
  void setDumpSpectrogram (boolean pbDump);

  /**
  		* Whether spectrogram wanted or not.
  		* @return <code>true</code> if spectrogram being dumped, <code>false</code> otherwise
  		*/
  boolean getDumpSpectrogram ();

  /**
  		* Indicates whether wave graph is wanted as an output.
  		* @param pbDump <code>true</code> if wanted, <code>false</code> if not
  		*/
  void setDumpWaveGraph (boolean pbDump);

  /**
  		* Whether wave graph wanted or not.
  		* @return <code>true</code> if graph wanted being dumped, <code>false</code> otherwise
  		*/
  boolean getDumpWaveGraph ();

  /**
  		* Sets ID of a subject currently being trained on.
  		* @param piSubjectID integer ID of the subject
  		*/
  void setCurrentSubject (int piSubjectID);

  /**
  		* Gets ID of a subject currently being trained on.
  		* @return integer ID of the subject
  		* @since 0.2.0
  		*/
  int getCurrentSubject ();

  /**
  		* Allows loading a sample loader plugin by its name.
  		* @param pstrClassName class name of the plugin sample loader module
  		* @throws MARFException if class cannot be loaded for any reason
  		* @since 0.3.0.5
  		*/
  void setSampleLoaderPluginClass (String pstrClassName) throws marf.net.server.corba.CORBACommunicationException;

  //Class getSampleLoaderPluginClass();
  org.omg.CORBA.Any getSampleLoaderPluginClass ();

  /**
  		* Allows loading a preprocessing plugin by its name.
  		* @param pstrClassName class name of the plugin preprocessing module
  		* @throws MARFException if class cannot be loaded for any reason
  		* @since 0.3.0.4
  		*/
  void setPreprocessingPluginClass (String pstrClassName) throws marf.net.server.corba.CORBACommunicationException;

  //Class getPreprocessingPluginClass();
  org.omg.CORBA.Any getPreprocessingPluginClass ();

  /**
  		* Allows loading a feature extraction plugin by its name.
  		* @param pstrClassName class name of the plugin feature extraction module
  		* @throws MARFException if class cannot be loaded for any reason
  		* @since 0.3.0.4
  		*/
  void setFeatureExtractionPluginClass (String pstrClassName) throws marf.net.server.corba.CORBACommunicationException;

  //Class getFeatureExtractionPluginClass();
  org.omg.CORBA.Any getFeatureExtractionPluginClass ();

  /**
  		* Allows loading a classification plugin by its name.
  		* @param pstrClassName class name of the plugin classification module
  		* @throws MARFException if class cannot be loaded for any reason
  		* @since 0.3.0.4
  		*/
  void setClassificationPluginClass (String pstrClassName) throws marf.net.server.corba.CORBACommunicationException;

  //Class getClassificationPluginClass();
  org.omg.CORBA.Any getClassificationPluginClass ();

  /**
  		* Returns a string representation of the MARF version.
  		* As of 0.3.0.3 MINOR_REVISION is also returned.
  		*
  		* @return version String
  		* @see #MINOR_REVISION
  		*/
  String getVersion ();

  /**
  		* Returns an integer representation of the MARF version.
  		* As of 0.3.0.3, MINOR_REVISION is included into calculations
  		* and the formula changed to begin with 1000 as a MAJOR_VERSION
  		* coefficient.
  		*
  		* @return integer version as <code>MAJOR_VERSION * 1000 + MINOR_VERSION * 100 + REVISION * 10 + MINOR_REVISION</code>
  		*
  		* @see #MAJOR_VERSION
  		* @see #MINOR_VERSION
  		* @see #REVISION
  		* @see #MINOR_REVISION
  		*/
  int getIntVersion ();

  /**
  		* Retrieves double version of MARF. Unlike the integer version, the double
  		* one begins with 100 and the minor revision is returned after the point,
  		* e.g. 123.4 for 1.2.3.4.
  		*
  		* @return double version as <code>MAJOR_VERSION * 100 + MINOR_VERSION * 10 + REVISION + MINOR_REVISION / 10</code>
  		*
  		* @see #MAJOR_VERSION
  		* @see #MINOR_VERSION
  		* @see #REVISION
  		* @see #MINOR_REVISION
  		*
  		* @since 0.3.0.3
  		*/
  double getDoubleVersion ();

  /**
  		* Returns a string representation of the current MARF configuration.
  		* @return configuration string
  		*/
  String getConfig ();

  /**
  		* Retrieves current <code>Sample</code> reference.
  		* @return Sample object
  		* @since 0.2.0
  		*/
  marf.net.server.corba.Storage.Sample getSample ();

  /**
  		* Retrieves current <code>SampleLoader</code> reference.
  		* @return SampleLoader object
  		* @since 0.2.0
  		*/
  marf.net.server.corba.Storage.ISampleLoaderCORBA getSampleLoader ();

  /**
  		* Retrieves current <code>Preprocessing</code> reference.
  		* @return Preprocessing object
  		* @since 0.2.0
  		*/
  marf.net.server.corba.Preprocessing.IPreprocessingCORBA getPreprocessing ();

  /**
  		* Retrieves current <code>FeatureExtraction</code> reference.
  		* @return FeatureExtraction object
  		* @since 0.2.0
  		*/
  marf.net.server.corba.FeatureExtraction.IFeatureExtractionCORBA getFeatureExtraction ();

  /**
  		* Retrieves current <code>Classification</code> reference.
  		* @return Classification object
  		* @since 0.2.0
  		*/
  marf.net.server.corba.Classification.IClassificationCORBA getClassification ();

  /**
  		* Queries for the final classification result.
  		* @return integer ID of the indentified subject
  		*/
  int queryResultID ();

  /**
  		* Gets the entire Result object of the likely outcome.
  		* @return Result ID and all the stats of the classification
  		*/
  marf.net.server.corba.Storage.Result getResult ();

  /**
  		* Gets the entire collection of results.
  		* @return ResultSet object with one or more results.
  		* @since 0.3.0.2
  		*/
  marf.net.server.corba.Storage.ResultSet getResultSet ();

  /**
  		* Recognition/Identification mode.
  		* @since 0.2.0
  		* @throws MARFException if there was an error in the pipeline
  		* or classification
  		*/
  void recognize () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Training mode.
  		* @since 0.2.0
  		* @throws MARFException if the subject is unset or there was
  		* an error in training in the underlying classification module
  		*/
  void train () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* The core processing pipeline. The pipeline work
  		* through almost entire process up until creation
  		* of the classification module. Then the application's
  		* choice depicts whether to call train() or classify()
  		* on this module via MARF's train() or recognize() methods.
  		* The pipeline is granularly synchronized on each object
  		* that gets instantiated, so no indirect blocking occurs
  		* on MARF itself (e.g. betwen the main thread and the inner
  		* threads of the framework that maybe accessing the MARF
  		* class concurrently).
  		*
  		* @throws MARFException in case any underlying error happens
  		* @see #train()
  		* @see #recognize()
  		*/
  void startRecognitionPipeline () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Checks for all necessary settings to be present.
  		* Specifically, checks whether preprocessing, feature
  		* extraction, classification methods are set as well as
  		* the audio sample format. The filename of the sample
  		* or a directory must also be present.
  		*
  		* @throws MARFException if any of the settings are unset
  		* @since 0.3.0.5
  		*/
  void checkSettings () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Meant to provide implementation of the buffered sample processing for large samples.
  		* Not implemented.
  		* @throws NotImplementedException
  		*/
  void streamedRecognition ();
  marf.net.server.corba.Storage.Configuration setConfiguration (marf.net.server.corba.Storage.Configuration poConfiguration) throws marf.net.server.corba.CORBACommunicationException;
  marf.net.server.corba.Storage.Configuration getConfiguration ();
} // interface IMARFServerCORBAOperations
