package marf.net.server.corba.Storage;


/**
* marf/net/server/corba/Storage/ISampleLoaderCORBAOperations.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from src/marf/net/server/corba/MARF.idl
* Sunday, August 13, 2006 11:30:44 PM EDT
*/


/**
	 * <p>CORBA Samle loading interface.</p>
	 *
	 * $Id: ISampleLoaderCORBAOperations.java,v 1.1 2007/02/19 01:14:07 mokhov Exp $
	 *
	 * @author Serguei Mokhov
	 * @since 0.3.0.6
	 * @version $Revision: 1.1 $
	 */
public interface ISampleLoaderCORBAOperations 
{

  /**
  		* Reads audio data from the sample's audio stream into padAudioData.
  		* @param padAudioData an array of doubles
  		* @return integer the number of datums read
  		* @throws StorageException if there was an error reading audio data
  		*/
  int readAudioData (marf.net.server.corba.Storage.AudioDataHolder padAudioData) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Writes audio data into the sample's audio stream.
  		* @param padAudioData an array of doubles
  		* @param piWords the number of audio data to written from the paiAudiodata
  		* @return the number of data written
  		* @throws StorageException if there was an error loading the sample
  		*/
  int writeAudioData (double[] padAudioData, int piWords) throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Assumes the file data is in the array of bytes for loading.
  	 * @param patFileAudioData the byte data of a sample to be read from
  	 * @return Sample object reference
  	 * @throws StorageException if there was an error loading the sample
  	 * @since 0.3.0.6
  	 */
  marf.net.server.corba.Storage.Sample loadSampleFromArray (byte[] patFileAudioData) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Same as loadSample(File) but takes filename as an argument.
  		* @param pstrFilename filename of a sample to be read from
  		* @return Sample object reference
  		* @throws StorageException if there was an error loading the sample
  		*/
  marf.net.server.corba.Storage.Sample loadSample (String pstrFilename) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Same as saveSample(File) but takes filename as an argument.
  		* @param pstrFilename filename of a sample to be saved to
  		* @throws StorageException if there was an error saving the sample
  		*/
  void saveSample (String pstrFilename) throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* <p><code>updateSample()</code> is just used whenever the
  		* <code>AudioInputStream</code> is assigned to a new value (wave file).
  		* Then you would simply call this method to update the
  		* <code>Sample</code> member with the contents of the new <code>AudioInputStream</code>.</p>
  		* @throws StorageException if there was an error updating the sample data array
  		*/
  void updateSample () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Resets the marker for the audio stream. Used after writing audio data
  		* into the sample's audio stream.
  		* @throws StorageException if there was an error resetting the audio stream
  		*/
  void reset () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Retrieves the length of the sample (# of audio data in the audio stream).
  		* @return sample size, long
  		* @throws StorageException if there was an error getting sample size
  		*/
  int getSampleSize () throws marf.net.server.corba.CORBACommunicationException;

  /**
  		* Returns internal reference to a Sample object.
  		* @return Sample reference
  		*/
  marf.net.server.corba.Storage.Sample getSample ();

  /**
  		* Sets internal sample reference from outside.
  		* @param poSample Sample object
  		*/
  void setSample (marf.net.server.corba.Storage.Sample poSample);
} // interface ISampleLoaderCORBAOperations
