package marf.net.server.corba.Storage;


/**
* marf/net/server/corba/Storage/ISampleLoaderCORBAPOA.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from src/marf/net/server/corba/MARF.idl
* Sunday, August 13, 2006 11:30:44 PM EDT
*/


/**
	 * <p>CORBA Samle loading interface.</p>
	 *
	 * $Id: ISampleLoaderCORBAPOA.java,v 1.1 2007/02/19 01:14:07 mokhov Exp $
	 *
	 * @author Serguei Mokhov
	 * @since 0.3.0.6
	 * @version $Revision: 1.1 $
	 */
public abstract class ISampleLoaderCORBAPOA extends org.omg.PortableServer.Servant
 implements marf.net.server.corba.Storage.ISampleLoaderCORBAOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("readAudioData", new java.lang.Integer (0));
    _methods.put ("writeAudioData", new java.lang.Integer (1));
    _methods.put ("loadSampleFromArray", new java.lang.Integer (2));
    _methods.put ("loadSample", new java.lang.Integer (3));
    _methods.put ("saveSample", new java.lang.Integer (4));
    _methods.put ("updateSample", new java.lang.Integer (5));
    _methods.put ("reset", new java.lang.Integer (6));
    _methods.put ("getSampleSize", new java.lang.Integer (7));
    _methods.put ("getSample", new java.lang.Integer (8));
    _methods.put ("setSample", new java.lang.Integer (9));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
  		* Reads audio data from the sample's audio stream into padAudioData.
  		* @param padAudioData an array of doubles
  		* @return integer the number of datums read
  		* @throws StorageException if there was an error reading audio data
  		*/
       case 0:  // ISampleLoaderCORBA/readAudioData
       {
         try {
           marf.net.server.corba.Storage.AudioDataHolder padAudioData = new marf.net.server.corba.Storage.AudioDataHolder ();
           padAudioData.value = marf.net.server.corba.Storage.AudioDataHelper.read (in);
           int $result = (int)0;
           $result = this.readAudioData (padAudioData);
           out = $rh.createReply();
           out.write_long ($result);
           marf.net.server.corba.Storage.AudioDataHelper.write (out, padAudioData.value);
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* Writes audio data into the sample's audio stream.
  		* @param padAudioData an array of doubles
  		* @param piWords the number of audio data to written from the paiAudiodata
  		* @return the number of data written
  		* @throws StorageException if there was an error loading the sample
  		*/
       case 1:  // ISampleLoaderCORBA/writeAudioData
       {
         try {
           double padAudioData[] = marf.net.server.corba.Storage.AudioDataHelper.read (in);
           int piWords = in.read_long ();
           int $result = (int)0;
           $result = this.writeAudioData (padAudioData, piWords);
           out = $rh.createReply();
           out.write_long ($result);
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  	 * Assumes the file data is in the array of bytes for loading.
  	 * @param patFileAudioData the byte data of a sample to be read from
  	 * @return Sample object reference
  	 * @throws StorageException if there was an error loading the sample
  	 * @since 0.3.0.6
  	 */
       case 2:  // ISampleLoaderCORBA/loadSampleFromArray
       {
         try {
           byte patFileAudioData[] = marf.net.server.corba.Storage.RawAudioDataHelper.read (in);
           marf.net.server.corba.Storage.Sample $result = null;
           $result = this.loadSampleFromArray (patFileAudioData);
           out = $rh.createReply();
           marf.net.server.corba.Storage.SampleHelper.write (out, $result);
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* Same as loadSample(File) but takes filename as an argument.
  		* @param pstrFilename filename of a sample to be read from
  		* @return Sample object reference
  		* @throws StorageException if there was an error loading the sample
  		*/
       case 3:  // ISampleLoaderCORBA/loadSample
       {
         try {
           String pstrFilename = in.read_string ();
           marf.net.server.corba.Storage.Sample $result = null;
           $result = this.loadSample (pstrFilename);
           out = $rh.createReply();
           marf.net.server.corba.Storage.SampleHelper.write (out, $result);
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* Same as saveSample(File) but takes filename as an argument.
  		* @param pstrFilename filename of a sample to be saved to
  		* @throws StorageException if there was an error saving the sample
  		*/
       case 4:  // ISampleLoaderCORBA/saveSample
       {
         try {
           String pstrFilename = in.read_string ();
           this.saveSample (pstrFilename);
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* <p><code>updateSample()</code> is just used whenever the
  		* <code>AudioInputStream</code> is assigned to a new value (wave file).
  		* Then you would simply call this method to update the
  		* <code>Sample</code> member with the contents of the new <code>AudioInputStream</code>.</p>
  		* @throws StorageException if there was an error updating the sample data array
  		*/
       case 5:  // ISampleLoaderCORBA/updateSample
       {
         try {
           this.updateSample ();
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* Resets the marker for the audio stream. Used after writing audio data
  		* into the sample's audio stream.
  		* @throws StorageException if there was an error resetting the audio stream
  		*/
       case 6:  // ISampleLoaderCORBA/reset
       {
         try {
           this.reset ();
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* Retrieves the length of the sample (# of audio data in the audio stream).
  		* @return sample size, long
  		* @throws StorageException if there was an error getting sample size
  		*/
       case 7:  // ISampleLoaderCORBA/getSampleSize
       {
         try {
           int $result = (int)0;
           $result = this.getSampleSize ();
           out = $rh.createReply();
           out.write_long ($result);
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  		* Returns internal reference to a Sample object.
  		* @return Sample reference
  		*/
       case 8:  // ISampleLoaderCORBA/getSample
       {
         marf.net.server.corba.Storage.Sample $result = null;
         $result = this.getSample ();
         out = $rh.createReply();
         marf.net.server.corba.Storage.SampleHelper.write (out, $result);
         break;
       }


  /**
  		* Sets internal sample reference from outside.
  		* @param poSample Sample object
  		*/
       case 9:  // ISampleLoaderCORBA/setSample
       {
         marf.net.server.corba.Storage.Sample poSample = marf.net.server.corba.Storage.SampleHelper.read (in);
         this.setSample (poSample);
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:ISampleLoaderCORBA:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public ISampleLoaderCORBA _this() 
  {
    return ISampleLoaderCORBAHelper.narrow(
    super._this_object());
  }

  public ISampleLoaderCORBA _this(org.omg.CORBA.ORB orb) 
  {
    return ISampleLoaderCORBAHelper.narrow(
    super._this_object(orb));
  }


} // class ISampleLoaderCORBAPOA
