/**
 * 
 */
package marf.net.server.delegates.MARF;

import java.io.Serializable;

import marf.Configuration;
import marf.MARF;
import marf.Classification.IClassification;
import marf.FeatureExtraction.IFeatureExtraction;
import marf.Preprocessing.IPreprocessing;
import marf.Storage.ISampleLoader;
import marf.Storage.ModuleParams;
import marf.Storage.Result;
import marf.Storage.ResultSet;
import marf.Storage.Sample;
import marf.util.MARFException;
import marf.util.NotImplementedException;


/**
 * @author mokhov
 *
 */
public class BasicMARFDelegate
implements IMARFServerDelegate
{

	/**
	 * 
	 */
	public BasicMARFDelegate()
	{
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#checkSettings()
	 */
	public void checkSettings()
	throws MARFException
	{
		MARF.checkSettings();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getClassification()
	 */
	public IClassification getClassification()
	{
		return MARF.getClassification();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getClassificationMethod()
	 */
	public int getClassificationMethod()
	{
		return MARF.getClassificationMethod();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getClassificationPluginClass()
	 */
	public Class getClassificationPluginClass()
	{
		return MARF.getClassificationPluginClass();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getConfig()
	 */
	public String getConfig()
	{
		return MARF.getConfig();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getCurrentSubject()
	 */
	public int getCurrentSubject()
	{
		return MARF.getCurrentSubject();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getDoubleVersion()
	 */
	public double getDoubleVersion()
	{
		return MARF.getDoubleVersion();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getDumpSpectrogram()
	 */
	public boolean getDumpSpectrogram()
	{
		return MARF.getDumpSpectrogram();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getDumpWaveGraph()
	 */
	public boolean getDumpWaveGraph()
	{
		return MARF.getDumpWaveGraph();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getFeatureExtraction()
	 */
	public IFeatureExtraction getFeatureExtraction()
	{
		return MARF.getFeatureExtraction();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getFeatureExtractionMethod()
	 */
	public int getFeatureExtractionMethod()
	{
		return MARF.getFeatureExtractionMethod();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getFeatureExtractionPluginClass()
	 */
	public Class getFeatureExtractionPluginClass()
	{
		return MARF.getFeatureExtractionPluginClass();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getIntVersion()
	 */
	public int getIntVersion()
	{
		return MARF.getIntVersion();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getModuleParams()
	 */
	public ModuleParams getModuleParams()
	{
		return MARF.getModuleParams();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getPreprocessing()
	 */
	public IPreprocessing getPreprocessing()
	{
		return MARF.getPreprocessing();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getPreprocessingMethod()
	 */
	public int getPreprocessingMethod()
	{
		return MARF.getPreprocessingMethod();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getPreprocessingPluginClass()
	 */
	public Class getPreprocessingPluginClass()
	{
		return MARF.getPreprocessingPluginClass();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getResult()
	 */
	public Result getResult()
	{
		return MARF.getResult();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getResultSet()
	 */
	public ResultSet getResultSet()
	{
		return MARF.getResultSet();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getSample()
	 */
	public Sample getSample()
	{
		return MARF.getSample();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getSampleFile()
	 */
	public String getSampleFile()
	{
		return MARF.getSampleFile();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getSampleFormat()
	 */
	public int getSampleFormat()
	{
		return MARF.getSampleFormat();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getSampleLoader()
	 */
	public ISampleLoader getSampleLoader()
	{
		return MARF.getSampleLoader();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getSampleLoaderPluginClass()
	 */
	public Class getSampleLoaderPluginClass()
	{
		return MARF.getSampleLoaderPluginClass();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getVersion()
	 */
	public String getVersion()
	{
		return MARF.getVersion();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#queryResultID()
	 */
	public int queryResultID()
	{
		return MARF.queryResultID();
	}

	/**
	 * Runs local pipeline.
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#recognize()
	 */
	public void recognize()
	throws MARFException
	{
		MARF.recognize();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setClassificationMethod(int)
	 */
	public void setClassificationMethod(int piClassificationMethod)
	throws MARFException
	{
		MARF.setClassificationMethod(piClassificationMethod);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setClassificationPluginClass(java.lang.Class)
	 */
	public void setClassificationPluginClass(Class poClass)
	throws MARFException
	{
		MARF.setClassificationPluginClass(poClass);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setClassificationPluginClass(java.lang.String)
	 */
	public void setClassificationPluginClass(String pstrClassName)
	throws MARFException
	{
		MARF.setClassificationPluginClass(pstrClassName);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setCurrentSubject(int)
	 */
	public void setCurrentSubject(int piSubjectID)
	{
		MARF.setCurrentSubject(piSubjectID);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setDumpSpectrogram(boolean)
	 */
	public void setDumpSpectrogram(boolean pbDump)
	{
		MARF.setDumpSpectrogram(pbDump);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setDumpWaveGraph(boolean)
	 */
	public void setDumpWaveGraph(boolean pbDump)
	{
		MARF.setDumpWaveGraph(pbDump);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setFeatureExtractionMethod(int)
	 */
	public void setFeatureExtractionMethod(int piFeatureExtractionMethod)
	throws MARFException
	{
		MARF.setFeatureExtractionMethod(piFeatureExtractionMethod);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setFeatureExtractionPluginClass(java.lang.Class)
	 */
	public void setFeatureExtractionPluginClass(Class poClass)
	throws MARFException
	{
		MARF.setFeatureExtractionPluginClass(poClass);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setFeatureExtractionPluginClass(java.lang.String)
	 */
	public void setFeatureExtractionPluginClass(String pstrClassName)
	throws MARFException
	{
		MARF.setClassificationPluginClass(pstrClassName);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setModuleParams(marf.Storage.ModuleParams)
	 */
	public void setModuleParams(ModuleParams poModuleParams)
	{
		MARF.setModuleParams(poModuleParams);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setPreprocessingMethod(int)
	 */
	public void setPreprocessingMethod(int piPreprocessingMethod)
	throws MARFException
	{
		MARF.setPreprocessingMethod(piPreprocessingMethod);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setPreprocessingPluginClass(java.lang.Class)
	 */
	public void setPreprocessingPluginClass(Class poClass)
	throws MARFException
	{
		MARF.setPreprocessingPluginClass(poClass);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setPreprocessingPluginClass(java.lang.String)
	 */
	public void setPreprocessingPluginClass(String pstrClassName)
	throws MARFException
	{
		MARF.setPreprocessingPluginClass(pstrClassName);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setSampleFile(java.lang.String)
	 */
	public void setSampleFile(String pstrFileName)
	{
		MARF.setSampleFile(pstrFileName);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setSampleFormat(int)
	 */
	public void setSampleFormat(int piSampleFormat)
	{
		MARF.setSampleFormat(piSampleFormat);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setSampleLoaderPluginClass(java.lang.Class)
	 */
	public void setSampleLoaderPluginClass(Class poClass)
	throws MARFException
	{
		MARF.setSampleLoaderPluginClass(poClass);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setSampleLoaderPluginClass(java.lang.String)
	 */
	public void setSampleLoaderPluginClass(String pstrClassName)
	throws MARFException
	{
		MARF.setSampleLoaderPluginClass(pstrClassName);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setSamplesDir(java.lang.String)
	 */
	public void setSamplesDir(String pstrSamplesDir)
	{
		MARF.setSamplesDir(pstrSamplesDir);
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#startRecognitionPipeline()
	 */
	public void startRecognitionPipeline()
	throws MARFException
	{
		// TODO: private
		//MARF.startRecognitionPipeline();
		throw new NotImplementedException();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#streamedRecognition()
	 */
	public void streamedRecognition()
	{
		MARF.streamedRecognition();
	}

	/**
	 * Runs locally.
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#train()
	 */
	public void train()
	throws MARFException
	{
		MARF.train();
	}

	
	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#getConfiguration()
	 */
	public Configuration getConfiguration()
	{
		return MARF.getConfiguration();
	}

	/**
	 * @see marf.net.server.delegates.MARF.IMARFServerDelegate#setConfiguration(marf.Configuration)
	 */
	public Configuration setConfiguration(Configuration poConfig)
	throws MARFException
	{
		return MARF.setConfiguration(poConfig);
	}

	
	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#abortTransaction(long)
	 */
	public boolean abortTransaction(long piTxnID) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#beginTransaction()
	 */
	public long beginTransaction(String pstrOperation) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#commitTransaction(long)
	 */
	public boolean commitTransaction(long piTxnID) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#prepareTransaction(long, java.io.Serializable)
	 */
	public boolean prepareTransaction(long piTxnID, Serializable poValue) {
		// TODO Auto-generated method stub
		return false;
	}
}

// EOF
