/**
 * 
 */
package marf.net.server.delegates.SampleLoader;

import java.io.File;
import java.io.InputStream;
import java.io.Serializable;

import marf.Storage.ISampleLoader;
import marf.Storage.Sample;
import marf.Storage.StorageException;
import marf.Storage.Loaders.WAVLoader;
import marf.util.InvalidSampleFormatException;

/**
 * @author mokhov
 *
 */
public class BasicSampleLoaderDelegate
implements ISampleLoaderDelegate
{
	protected ISampleLoader oBusinessLogicDelegate = null;

	/**
	 * 
	 */
	public BasicSampleLoaderDelegate()
	throws InvalidSampleFormatException
	{
		super();
		oBusinessLogicDelegate = new WAVLoader();
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#abortTransaction(long)
	 */
	public boolean abortTransaction(long piTxnID) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#beginTransaction()
	 */
	public long beginTransaction(String pstrOperation) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#commitTransaction(long)
	 */
	public boolean commitTransaction(long piTxnID) {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.IDelegate#prepareTransaction(long, java.io.Serializable)
	 */
	public boolean prepareTransaction(long piTxnID, Serializable poValue) {
		// TODO Auto-generated method stub
		return false;
	}

	
	
	/**
	 * @see marf.Storage.ISampleLoader#getSample()
	 */
	public Sample getSample()
	{
		return this.oBusinessLogicDelegate.getSample();
	}

	/**
	 * @see marf.Storage.ISampleLoader#getSampleSize()
	 */
	public long getSampleSize()
	throws StorageException
	{
		return this.oBusinessLogicDelegate.getSampleSize();
	}

	/**
	 * @see marf.Storage.ISampleLoader#loadSample(java.io.File)
	 */
	public Sample loadSample(File poInFile)
	throws StorageException
	{
		return this.oBusinessLogicDelegate.loadSample(poInFile);
	}

	/**
	 * @see marf.Storage.ISampleLoader#loadSample(java.lang.String)
	 */
	public Sample loadSample(String pstrFilename)
	throws StorageException
	{
		return this.oBusinessLogicDelegate.loadSample(pstrFilename);
	}

	/**
	 * @see marf.Storage.ISampleLoader#loadSample(byte[])
	 */
	public Sample loadSample(byte[] patFileAudioData) throws StorageException {
		return this.oBusinessLogicDelegate.loadSample(patFileAudioData);
	}

	/**
	 * @see marf.Storage.ISampleLoader#loadSample(java.io.InputStream)
	 */
	public Sample loadSample(InputStream poAudioDataInputStream) throws StorageException {
		return this.oBusinessLogicDelegate.loadSample(poAudioDataInputStream);
	}

	/**
	 * @see marf.Storage.ISampleLoader#readAudioData(double[])
	 */
	public int readAudioData(double[] padAudioData)
	throws StorageException
	{
		return this.oBusinessLogicDelegate.readAudioData(padAudioData);
	}

	/**
	 * @see marf.Storage.ISampleLoader#reset()
	 */
	public void reset()
	throws StorageException
	{
		this.oBusinessLogicDelegate.reset();
	}

	/**
	 * @see marf.Storage.ISampleLoader#saveSample(java.io.File)
	 */
	public void saveSample(File poOutFile)
	throws StorageException
	{
		this.oBusinessLogicDelegate.saveSample(poOutFile);
	}

	/**
	 * @see marf.Storage.ISampleLoader#saveSample(java.lang.String)
	 */
	public void saveSample(String pstrFilename)
	throws StorageException
	{
		this.oBusinessLogicDelegate.saveSample(pstrFilename);
	}

	/**
	 * @see marf.Storage.ISampleLoader#setSample(marf.Storage.Sample)
	 */
	public void setSample(Sample poSample)
	{
		this.oBusinessLogicDelegate.setSample(poSample);
	}

	/**
	 * @see marf.Storage.ISampleLoader#updateSample()
	 */
	public void updateSample()
	throws StorageException
	{
		this.oBusinessLogicDelegate.updateSample();
	}

	/**
	 * @see marf.Storage.ISampleLoader#writeAudioData(double[], int)
	 */
	public int writeAudioData(double[] padAudioData, int piWords)
	throws StorageException
	{
		return this.oBusinessLogicDelegate.writeAudioData(padAudioData, piWords);
	}
}

// EOF
