package marf.net.server.frontend.corba.SpeakerIdent;


/**
* marf/net/server/frontend/corba/SpeakerIdent/ISpeakerIdentCORBAOperations.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from src/marf/net/server/frontend/corba/Frontends.idl
* Sunday, August 13, 2006 11:30:45 PM EDT
*/

public interface ISpeakerIdentCORBAOperations 
{

  /**
  	 * Main body.
  	 * @param argv command-line arguments
  	 */
  void start (String[] argv);

  /**
  	 * Indetifies a speaker using MARF given configuration,
  	 * wave filename, and possibly expected speaker ID.
  	 *
  	 * @param pstrConfig configuration string for stats
  	 * @param pstrFilename name of the wave file with voice sample to identify
  	 * @param piExpectedID expected speaker ID; if -1 then no stats is kept
  	 *
  	 * @throws MARFException in case of any error while processing is in MARF
  	 */
  void ident (marf.net.server.corba.Storage.Configuration poConfig, String pstrFilename, byte[] patSampleData, int piExpectedID) throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Updates training set with a new sample from a given file.
  	 *
  	 * @param pstrFilename name of the wave file with voice sample train the system on
  	 *
  	 * @throws MARFException in case of any error while processing is in MARF
  	 */
  void train (marf.net.server.corba.Storage.Configuration poConfig, String pstrFilename, byte[] patSampleData) throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Retrieves String representation of the application's version.
  	 * @return version String
  	 */
  String getVersion ();

  /**
  	 * Retrieves integer representation of the application's version.
  	 * @return integer version
  	 */
  int getIntVersion ();

  /**
  	 * Makes sure the applications isn't run against older MARF version.
  	 * Exits with 1 if the MARF version is too old.
  	 */
  void validateVersions () throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Composes the current configuration of in a string form.
  	 *
  	 * @param pstrArgv set of configuration options passed through the command line;
  	 * can be null or empty. If latter is the case, MARF itself is queried for its
  	 * numerical set up inside.
  	 *
  	 * @return the current configuration setup
  	 */
  String getConfigString (String[] pastrArgv);

  /**
  	 * Sets default MARF configuration parameters as normalization
  	 * for preprocessing, FFT for feature extraction, Eucludean
  	 * distance for training and classification with no spectrogram
  	 * dumps and no debug information, assuming WAVE file format.
  	 *
  	 * @throws MARFException
  	 */
  marf.net.server.corba.Storage.Configuration setDefaultConfig () throws marf.net.server.corba.CORBACommunicationException;

  /**
  	 * Customizes MARF's configuration based on the options.
  	 * @throws MARFException if some options are out of range
  	 */
  void setCustomConfig (marf.net.server.corba.Storage.Configuration poConfig) throws marf.net.server.corba.CORBACommunicationException;

  // 	raises (CORBACommunicationException);
  String[] listStats ();
  String[] listBestResultStats ();
  String[] listTopResultsStats (int piTopN);
  void resetStats ();
} // interface ISpeakerIdentCORBAOperations
