package marf.net.server.frontend.corba.SpeakerIdent;


/**
* marf/net/server/frontend/corba/SpeakerIdent/ISpeakerIdentCORBAPOA.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from src/marf/net/server/frontend/corba/Frontends.idl
* Sunday, August 13, 2006 11:30:45 PM EDT
*/

public abstract class ISpeakerIdentCORBAPOA extends org.omg.PortableServer.Servant
 implements marf.net.server.frontend.corba.SpeakerIdent.ISpeakerIdentCORBAOperations, org.omg.CORBA.portable.InvokeHandler
{

  // Constructors

  private static java.util.Hashtable _methods = new java.util.Hashtable ();
  static
  {
    _methods.put ("start", new java.lang.Integer (0));
    _methods.put ("ident", new java.lang.Integer (1));
    _methods.put ("train", new java.lang.Integer (2));
    _methods.put ("getVersion", new java.lang.Integer (3));
    _methods.put ("getIntVersion", new java.lang.Integer (4));
    _methods.put ("validateVersions", new java.lang.Integer (5));
    _methods.put ("getConfigString", new java.lang.Integer (6));
    _methods.put ("setDefaultConfig", new java.lang.Integer (7));
    _methods.put ("setCustomConfig", new java.lang.Integer (8));
    _methods.put ("listStats", new java.lang.Integer (9));
    _methods.put ("listBestResultStats", new java.lang.Integer (10));
    _methods.put ("listTopResultsStats", new java.lang.Integer (11));
    _methods.put ("resetStats", new java.lang.Integer (12));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (String $method,
                                org.omg.CORBA.portable.InputStream in,
                                org.omg.CORBA.portable.ResponseHandler $rh)
  {
    org.omg.CORBA.portable.OutputStream out = null;
    java.lang.Integer __method = (java.lang.Integer)_methods.get ($method);
    if (__method == null)
      throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);

    switch (__method.intValue ())
    {

  /**
  	 * Main body.
  	 * @param argv command-line arguments
  	 */
       case 0:  // SpeakerIdent/ISpeakerIdentCORBA/start
       {
         String argv[] = marf.net.server.frontend.corba.SpeakerIdent.ArgumentVectorHelper.read (in);
         this.start (argv);
         out = $rh.createReply();
         break;
       }


  /**
  	 * Indetifies a speaker using MARF given configuration,
  	 * wave filename, and possibly expected speaker ID.
  	 *
  	 * @param pstrConfig configuration string for stats
  	 * @param pstrFilename name of the wave file with voice sample to identify
  	 * @param piExpectedID expected speaker ID; if -1 then no stats is kept
  	 *
  	 * @throws MARFException in case of any error while processing is in MARF
  	 */
       case 1:  // SpeakerIdent/ISpeakerIdentCORBA/ident
       {
         try {
           marf.net.server.corba.Storage.Configuration poConfig = marf.net.server.corba.Storage.ConfigurationHelper.read (in);
           String pstrFilename = in.read_string ();
           byte patSampleData[] = marf.net.server.frontend.corba.SpeakerIdent.RawAudioDataHelper.read (in);
           int piExpectedID = in.read_long ();
           this.ident (poConfig, pstrFilename, patSampleData, piExpectedID);
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  	 * Updates training set with a new sample from a given file.
  	 *
  	 * @param pstrFilename name of the wave file with voice sample train the system on
  	 *
  	 * @throws MARFException in case of any error while processing is in MARF
  	 */
       case 2:  // SpeakerIdent/ISpeakerIdentCORBA/train
       {
         try {
           marf.net.server.corba.Storage.Configuration poConfig = marf.net.server.corba.Storage.ConfigurationHelper.read (in);
           String pstrFilename = in.read_string ();
           byte patSampleData[] = marf.net.server.frontend.corba.SpeakerIdent.RawAudioDataHelper.read (in);
           this.train (poConfig, pstrFilename, patSampleData);
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  	 * Retrieves String representation of the application's version.
  	 * @return version String
  	 */
       case 3:  // SpeakerIdent/ISpeakerIdentCORBA/getVersion
       {
         String $result = null;
         $result = this.getVersion ();
         out = $rh.createReply();
         out.write_string ($result);
         break;
       }


  /**
  	 * Retrieves integer representation of the application's version.
  	 * @return integer version
  	 */
       case 4:  // SpeakerIdent/ISpeakerIdentCORBA/getIntVersion
       {
         int $result = (int)0;
         $result = this.getIntVersion ();
         out = $rh.createReply();
         out.write_long ($result);
         break;
       }


  /**
  	 * Makes sure the applications isn't run against older MARF version.
  	 * Exits with 1 if the MARF version is too old.
  	 */
       case 5:  // SpeakerIdent/ISpeakerIdentCORBA/validateVersions
       {
         try {
           this.validateVersions ();
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  	 * Composes the current configuration of in a string form.
  	 *
  	 * @param pstrArgv set of configuration options passed through the command line;
  	 * can be null or empty. If latter is the case, MARF itself is queried for its
  	 * numerical set up inside.
  	 *
  	 * @return the current configuration setup
  	 */
       case 6:  // SpeakerIdent/ISpeakerIdentCORBA/getConfigString
       {
         String pastrArgv[] = marf.net.server.frontend.corba.SpeakerIdent.ArgumentVectorHelper.read (in);
         String $result = null;
         $result = this.getConfigString (pastrArgv);
         out = $rh.createReply();
         out.write_string ($result);
         break;
       }


  /**
  	 * Sets default MARF configuration parameters as normalization
  	 * for preprocessing, FFT for feature extraction, Eucludean
  	 * distance for training and classification with no spectrogram
  	 * dumps and no debug information, assuming WAVE file format.
  	 *
  	 * @throws MARFException
  	 */
       case 7:  // SpeakerIdent/ISpeakerIdentCORBA/setDefaultConfig
       {
         try {
           marf.net.server.corba.Storage.Configuration $result = null;
           $result = this.setDefaultConfig ();
           out = $rh.createReply();
           marf.net.server.corba.Storage.ConfigurationHelper.write (out, $result);
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  /**
  	 * Customizes MARF's configuration based on the options.
  	 * @throws MARFException if some options are out of range
  	 */
       case 8:  // SpeakerIdent/ISpeakerIdentCORBA/setCustomConfig
       {
         try {
           marf.net.server.corba.Storage.Configuration poConfig = marf.net.server.corba.Storage.ConfigurationHelper.read (in);
           this.setCustomConfig (poConfig);
           out = $rh.createReply();
         } catch (marf.net.server.corba.CORBACommunicationException $ex) {
           out = $rh.createExceptionReply ();
           marf.net.server.corba.CORBACommunicationExceptionHelper.write (out, $ex);
         }
         break;
       }


  // 	raises (CORBACommunicationException);
       case 9:  // SpeakerIdent/ISpeakerIdentCORBA/listStats
       {
         String $result[] = null;
         $result = this.listStats ();
         out = $rh.createReply();
         marf.net.server.frontend.corba.SpeakerIdent.ArgumentVectorHelper.write (out, $result);
         break;
       }

       case 10:  // SpeakerIdent/ISpeakerIdentCORBA/listBestResultStats
       {
         String $result[] = null;
         $result = this.listBestResultStats ();
         out = $rh.createReply();
         marf.net.server.frontend.corba.SpeakerIdent.ArgumentVectorHelper.write (out, $result);
         break;
       }

       case 11:  // SpeakerIdent/ISpeakerIdentCORBA/listTopResultsStats
       {
         int piTopN = in.read_long ();
         String $result[] = null;
         $result = this.listTopResultsStats (piTopN);
         out = $rh.createReply();
         marf.net.server.frontend.corba.SpeakerIdent.ArgumentVectorHelper.write (out, $result);
         break;
       }

       case 12:  // SpeakerIdent/ISpeakerIdentCORBA/resetStats
       {
         this.resetStats ();
         out = $rh.createReply();
         break;
       }

       default:
         throw new org.omg.CORBA.BAD_OPERATION (0, org.omg.CORBA.CompletionStatus.COMPLETED_MAYBE);
    }

    return out;
  } // _invoke

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:SpeakerIdent/ISpeakerIdentCORBA:1.0"};

  public String[] _all_interfaces (org.omg.PortableServer.POA poa, byte[] objectId)
  {
    return (String[])__ids.clone ();
  }

  public ISpeakerIdentCORBA _this() 
  {
    return ISpeakerIdentCORBAHelper.narrow(
    super._this_object());
  }

  public ISpeakerIdentCORBA _this(org.omg.CORBA.ORB orb) 
  {
    return ISpeakerIdentCORBAHelper.narrow(
    super._this_object(orb));
  }


} // class ISpeakerIdentCORBAPOA
