package marf.net.server.rmi.util;

import marf.util.InvalidSampleFormatException;


/**
 * Responsible for translating common MARF and CORBA Sample data structure to RMI
 * and vice versa.
 *
 * @author mokhov
 *
 */
public class MARFObjectAdapter
{
	/**
	 *
	 */
	private MARFObjectAdapter()
	{
	}

	public static final marf.net.server.rmi.Storage.Sample getRMISample(marf.net.server.corba.Storage.Sample poCORBASample)
	throws InvalidSampleFormatException
	{
		marf.net.server.rmi.Storage.Sample oSample = new marf.net.server.rmi.Storage.Sample(poCORBASample.iFormat, poCORBASample.adSample);
		return oSample;
	}

	public static final marf.net.server.corba.Storage.Sample getCORBASample(marf.net.server.rmi.Storage.Sample poRMISample)
	{
		return new marf.net.server.corba.Storage.Sample(poRMISample.getFormat(), poRMISample.getSampleArray());
	}

	public static final marf.Storage.Sample getMARFSample(marf.net.server.rmi.Storage.Sample poRMISample)
	throws InvalidSampleFormatException
	{
		marf.Storage.Sample oSample = new marf.Storage.Sample(poRMISample.getFormat());
		oSample.setSampleArray(poRMISample.getSampleArray());
		return oSample;
	}

	public static final marf.net.server.rmi.Storage.Sample getRMISample(marf.Storage.Sample poMARFSample)
	{
		return new marf.net.server.rmi.Storage.Sample(poMARFSample.getAudioFileFormatCode(), poMARFSample.getSampleArray());
	}
}

// EOF
