/**
 * 
 */
package marf.net.server.ws.Classification;

import java.rmi.RemoteException;

import marf.Classification.ClassificationException;
import marf.net.server.delegates.Classification.RecoverableClassificationDelegate;
import marf.net.server.ws.FeatureExtraction.IFeatureExtractionWS;
import marf.net.server.ws.util.RemoteObjectReference;
import marf.net.server.ws.util.WSUtils;


/**
 * WS-specific classification servant.
 * 
 * @author mokhov
 *
 */
public class ClassificationServant
extends RecoverableClassificationDelegate
implements IClassificationWS
{

	/**
	 * Cannot be delegated. 
	 */
	private RemoteObjectReference oFeatureExtractionRef = null;
	
	private IFeatureExtractionWS oFeatureExtractionRemote = null;
	
	/**
	 * @throws ClassificationException
	 */
	public ClassificationServant() throws ClassificationException {
		super();
		// TODO Auto-generated constructor stub
	}

	
	/* (non-Javadoc)
	 * @see marf.net.server.ws.Classification.IClassificationWS#getRemoteFeatureExtraction()
	 */
	public RemoteObjectReference getRemoteFeatureExtraction() throws RemoteException {
		return this.oFeatureExtractionRef;
	}


	/* (non-Javadoc)
	 * @see marf.net.server.ws.Classification.IClassificationWS#setRemoteFeatureExtraction(marf.net.server.ws.util.RemoteObjectReference)
	 */
	public void setRemoteFeatureExtraction(RemoteObjectReference poFeatureExtraction) throws RemoteException {
		try
		{
			this.oFeatureExtractionRef = poFeatureExtraction;
			oFeatureExtractionRemote = WSUtils.connectToWSFeatureExtractionService(this.oFeatureExtractionRef);
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
	}

	

	/* (non-Javadoc)
	 * @see marf.net.server.delegates.Classification.BasicClassificationDelegate#classify()
	 */
	public synchronized boolean classify() throws ClassificationException {
		try
		{
			return super.classify(this.oFeatureExtractionRemote.getFeaturesArray());
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
	}


	/* (non-Javadoc)
	 * @see marf.net.server.delegates.Classification.BasicClassificationDelegate#train()
	 */
	public boolean train() throws ClassificationException {
		try
		{
			return super.train(this.oFeatureExtractionRemote.getFeaturesArray());
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
	}

	/**
	 * @param argv
	 */
	public static final void main(String[] argv)
	{
		
	}
}

// EOF
