/**
 * 
 */
package marf.net.server.ws.FeatureExtraction;

import java.rmi.RemoteException;

import marf.FeatureExtraction.FeatureExtractionException;
import marf.net.server.delegates.FeatureExtraction.BasicFeatureExtractionDelegate;
import marf.net.server.ws.Preprocessing.IPreprocessingWS;
import marf.net.server.ws.util.RemoteObjectReference;
import marf.net.server.ws.util.WSUtils;

/**
 * @author mokhov
 *
 */
public class FeatureExtractionServant extends BasicFeatureExtractionDelegate
		implements IFeatureExtractionWS {

	protected RemoteObjectReference oPreprocessingRef = null;

	protected IPreprocessingWS oPreprocessingRemote = null;
	
	/**
	 * 
	 */
	public FeatureExtractionServant() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @see marf.net.server.ws.FeatureExtraction.IFeatureExtractionWS#getRemotePreprocessing()
	 */
	public RemoteObjectReference getRemotePreprocessing()
			throws RemoteException {
		return this.oPreprocessingRef;
	}

	/**
	 * @see marf.net.server.ws.FeatureExtraction.IFeatureExtractionWS#setRemotePreprocessing(marf.net.server.ws.util.RemoteObjectReference)
	 */
	public void setRemotePreprocessing(RemoteObjectReference poPreprocessing)
			throws RemoteException {
		try
		{
			this.oPreprocessingRef = poPreprocessing;
			this.oPreprocessingRemote = WSUtils.connectToWSPreprocessingService(this.oPreprocessingRef);
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
	}

	/**
	 * @see marf.net.server.delegates.FeatureExtraction.BasicFeatureExtractionDelegate#extractFeatures()
	 */
	public boolean extractFeatures()
	throws FeatureExtractionException
	{
		try
		{
			return extractFeatures(this.oPreprocessingRemote.getSample().getSampleArray());
		}
		catch(Exception e)
		{
			throw new RuntimeException(e);
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

}
